<template>
  <div>

    <div class="red mb-5 text-center">Note : * Wajib diisi</div>

    <b-alert
    :show="dismissCountDown"
    dismissible
    variant="danger"
    @dismissed="dismissCountDown=0"
    @dismiss-count-down="countDownChanged"
    >
    <p>Maaf terdapat gangguan, silahkan coba kembali</p>
    <b-progress
    variant="danger"
    :max="dismissSecs"
    :value="dismissCountDown"
    height="2px"
    ></b-progress>
  </b-alert>
  <form>

    <div class="row">
      <div class="form-group col-md-12 col-lg-6">
        <label for="">Nama Lengkap (Berdasarkan Jenis Inovator) <span class="red">*</span>
        </label>
        <input type="text" name="nama" class="form-control" placeholder="Nama Lengkap"
        v-model="register.nama"
        v-validate="'required'"
        >
        <div class="text-danger">{{ veeErrors.first('nama') }}</div>
        <div class="help-block" v-if="errors">{{ errors['nama'] }}</div>
      </div>

      <div class="form-group col-md-12 col-lg-6">
        <label for="">Nama Penanggung Jawab 
          <span>(PIC-Person In Charge)</span>
        </label>
        <input type="text" name="nama_pic" class="form-control" placeholder="Nama Lengkap Penanggung Jawab" 
        v-model="register.nama_pic"
        >
        <div class="text-danger">{{ veeErrors.first('nama_pic') }}</div>
        <div class="help-block" v-if="errors">{{ errors['nama_pic'] }}</div>
      </div>
    </div>

    <div class="row">
      <div class="form-group col-md-12 col-lg-6">
        <label for="">Email Utama (for login) </label>
        <span class="red">*</span>
        <input type="email" name="email" class="form-control" placeholder="Alamat Email" 
        v-model="register.email"
        v-validate="'required|email|email_exists'"
        >
        <div class="text-danger">{{ veeErrors.first('email') }}</div>
        <div class="help-block" v-if="errors">{{ errors['email'] }}</div>
      </div>

      <div class="form-group col-md-12 col-lg-6">
        <label for="">Email Cadangan</label>
        <input type="email" name="email_cadangan" class="form-control" placeholder="Alamat Email Cadangan" 
        v-model="register.email_cadangan"
        v-validate="'email'"
        >
        <div class="text-danger">{{ veeErrors.first('email_cadangan') }}</div>
        <div class="help-block" v-if="errors">{{ errors['email_cadangan'] }}</div>
      </div>
    </div>

    <div class="row">
      <div class="form-group col-md-12 col-lg-6">
        <label for="">Nomor Kontak Utama</label>
        <span class="red">*</span>
        <input type="text" name="kontak" class="form-control" placeholder="Nomor Kontak Utama"
        v-model="register.kontak"
        v-validate="'required|numeric'"
        >
        <div class="text-danger">{{ veeErrors.first('kontak') }}</div>
        <div class="help-block" v-if="errors">{{ errors['kontak'] }}</div>
      </div>

      <div class="form-group col-md-12 col-lg-6">
        <label for="">Nomor Kontak Cadangan </label>
        <input type="text" name="kontak_cadangan" class="form-control" placeholder="Nomor Kontak Cadangan"
        v-model="register.kontak_cadangan"
        v-validate="'numeric'"
        >
        <div class="text-danger">{{ veeErrors.first('kontak_cadangan') }}</div>
        <div class="help-block" v-if="errors">{{ errors['kontak_cadangan'] }}</div>
      </div>
    </div>

    <div class="row">
      <div class="form-group col-md-12 col-lg-6">
        <label for="">Alamat Jalan</label>
        <span class="red">*</span>
        <input type="text" name="jalan" class="form-control" placeholder="Alamat Jalan"
        v-model="register.jalan"
        v-validate="'required'"
        >
        <div class="text-danger">{{ veeErrors.first('jalan') }}</div>
        <div class="help-block" v-if="errors">{{ errors['jalan'] }}</div>
      </div>

      <div class="form-group col-md-12 col-lg-6">
        <label for="">Desa/Kelurahan</label>
        <span class="red">*</span>
        <input type="text" name="desa" class="form-control" placeholder="Desa/Kelurahan" 
        v-model="register.desa"
        v-validate="'required'"
        >
        <div class="text-danger">{{ veeErrors.first('desa') }}</div>
        <div class="help-block" v-if="errors">{{ errors['desa'] }}</div>
      </div>
    </div>

    <div class="row">
      <div class="form-group col-md-12 col-lg-4">
        <label for="">Kecamatan</label>
        <span class="red">*</span>
        <input type="text" name="kecamatan" class="form-control" placeholder="Kecamatan"
        v-model="register.kecamatan"
        v-validate="'required'"
        >
        <div class="text-danger">{{ veeErrors.first('kecamatan') }}</div>
        <div class="help-block" v-if="errors">{{ errors['kecamatan'] }}</div>
      </div>

      <div class="form-group col-md-12 col-lg-4">
        <label for="">Kota</label>
        <span class="red">*</span>
        <input type="text" name="kota" class="form-control" placeholder="Kota" 
        v-model="register.kota"
        v-validate="'required'"
        >
        <div class="text-danger">{{ veeErrors.first('kota') }}</div>
        <div class="help-block" v-if="errors">{{ errors['kota'] }}</div>
      </div>

      <div class="form-group col-md-12 col-lg-4">
        <label for="">Provinsi</label>
        <span class="red">*</span>
        <input type="text" name="provinsi" class="form-control" placeholder="Provinsi" 
        v-model="register.provinsi"
        v-validate="'required'"
        >
        <div class="text-danger">{{ veeErrors.first('provinsi') }}</div>
        <div class="help-block" v-if="errors">{{ errors['provinsi'] }}</div>
      </div>
    </div>

    <div class="row">
      <div class="form-group col-md-12 col-lg-6">
        <label for="">Kategori Inovator</label>
        <span class="red">*</span>
        <b-form-select name="kategori" class="form-select"
        :options="kategori"
        v-model="setKategori" 
        v-validate="'required'"
        @change="getJenis()" 
        ></b-form-select>
        <div class="text-danger">{{ veeErrors.first('kategori') }}</div>
        <div class="help-block" v-if="errors">{{ errors['kategori'] }}</div>
      </div>

      <div class="form-group col-md-12 col-lg-6">
        <label for="">Jenis Inovator</label>
        <span class="red">*</span>
        <b-form-select name="jenis" class="form-select"
        :options="jenis" 
        v-model="setJenis" 
        v-validate="'required'"
        ></b-form-select>
        <div class="text-danger">{{ veeErrors.first('jenis') }}</div>
        <div class="help-block" v-if="errors">{{ errors['jenis'] }}</div>
      </div>
    </div>

    <div class="row">
      <div class="form-group col-md-12 col-lg-6 ">
        <label for="">Password</label>
        <span class="red">*</span>
        <input type="password" name="password" class="form-control" placeholder="Password" 
        v-model="register.password"
        v-validate="'required|min:6'"
        ref="password"
        >
        <div class="text-danger">{{ veeErrors.first('password') }}</div>
        <div class="help-block" v-if="errors">{{ errors['password'] }}</div>
      </div>

      <div class="form-group col-md-12 col-lg-6">
        <label for="">Password Confirmation</label>
        <span class="red">*</span>
        <input type="password" name="password_confirmation" class="form-control" placeholder="Konfirmasi Password"
        v-model="register.password_confirmation"
        v-validate="'required|confirmed:password'"
        >
        <div class="text-danger">{{ veeErrors.first('password_confirmation') }}</div>
      </div>
    </div>

  <div class="row">
      <div class="form-group col-md-12">
        <div>
      <label for="">Lokasi</label>
      <span class="red">*</span>
      <!-- <div>(Lakukan pencarian otomatis atau input koordinat manual)</div> -->
      <div>
        <GmapAutocomplete @place_changed='setPlace' placeholder="Cari Lokasi"/>
        <button @click.prevent='addMarker' class="btn btn-primary font-weight-bold btn-sm">Tambah</button>
      </div>
      <!-- <p>Input koordinat manual:</p> -->
      <input type="hidden" name="map" class="form-control map" 
      placeholder='{"lat":-8.655536, "lng":115.183756}'
      v-model="register.map"
      v-validate="'required'"
      >
      <div class="text-danger">{{ veeErrors.first('map') }}</div>
      <div class="help-block" v-if="errors">{{ errors['map'] }}</div>
    </div>
    <br>
         <GmapMap
            :center="center"
            :zoom="12"
            map-type-id="roadmap"
            style="width: 100%; height: 400px"
            >

            <GmapMarker
            :key="index"
            v-for="(m, index) in markers"
            :position="m.position"
            @click="center=m.position"
            :draggable="true"
            @drag="updateCoordinates"
            />
          </GmapMap>
      </div>
    </div>

     <div class="row">
      <div class="form-group col">
        <!-- <a href="/" class="btn btn-danger text-3 font-weight-bold px-4 py-2">Batal</a> -->
        <input type="submit" value="Daftar" class="btn btn-success text-3 font-weight-bold px-4 py-2" @click.prevent="submitRegister">
      </div>
    </div>
  </form>

  <div>

  <!-- <b-button id="show-btn" @click="$bvModal.show('showModal')">Open Modal</b-button> -->
  <b-modal id="showModal" hide-footer>
    <!-- <template #modal-title>
      Using <code>$bvModal</code> Methods
    </template> -->
    <div class="d-block text-center">
      <h4>Loading, Please wait...</h4>
      <b-spinner variant="primary" label="Text Centered" style="width: 3rem; height: 3rem;"></b-spinner>
    </div>
    <!-- <b-button class="mt-3" block @click="$bvModal.hide('showModal')">Close Me</b-button> -->
  </b-modal>

</div> 

</div>
</template>

<script>
import AxiosMixin from "./mixins/axiosMixins.js";



export default {
  props: ["dataprop"],
  mixins: [AxiosMixin],
  name: 'GoogleMap',
  data() {
    return {
      url: "",
      type: "",
      register: {},
      setKategori: null,
      kategori:
      [
        {value: null, text: 'Pilih Kategori Inovator', disabled: true},
        {value:{id:"1"}, text:'OPD'},
        {value:{id:"2"}, text:'NON OPD'},
      ],
      setJenis: null,
      jenis: [],
      dismissSecs: 5,
      dismissCountDown: 0,
      showDismissibleAlert: false,

      center: {
        lat: -8.650000,
        lng: 115.216667
      },
      places: [],
      markers: [],
      currentPlace: null,
      errors: null,
      
    }
  },

  mounted() {
    this.geolocate();
  },

  created() {
    this.initial();
    //Validator Extend

   this.$validator.extend('email_exists', {
            getMessage: field => `The email is already in the system.`,
            validate: value => {
              // console.log(value)
                return axios.get('checkemail/'+value).then(response => {
                  // console.log(response.data.valid)
                    return {
                        valid: response.data.valid // Your api could return a response containing a 'valid property'
                    }
                }).catch(error=> { return { error: response.error.val } });
            }
        });

  },

  methods: {

    initial() {},

    getJenis(){
      this.jenis = []
      // console.log(this.setKategori.id)
      if(this.setKategori.id==='2'){
        this.jenis = [
          {value:{id:"1"}, text:'Perorangan'},
          {value:{id:"2"}, text:'Komunitas'},
          {value:{id:"3"}, text:'Pelajar'},
          {value:{id:"4"}, text:'Mahasiswa'},
          {value:{id:"5"}, text:'Akademisi'},
          {value:{id:"6"}, text:'Lembaga'}
        ]
        this.setJenis = {id:"1"}
      }

      if(this.setKategori.id==='1'){
        this.jenis = [{value:{id:"7"}, text:'Organisasi Perangkat Daerah'}];
        this.setJenis = {id:"7"}
      }
    },
    submit(value){
      this.register.kategori = this.setKategori.id
      this.register.jenis = this.setJenis.id
      let formData = this.formData(this.register)
      let url = `registrasi`
      //on kan loading proses
      this.$bvModal.show('showModal')

      axios.post(url,formData).then(res => {
        //off kan loading proses
        if (res.data.message === 'sukses'){
          this.$bvModal.hide('showModal')
          let data = this.register
          // console.log(data)
          let dataEmit = {
            action:'notif',
            data
          }
          this.$emit("data-register",dataEmit);
        }
        else{
          this.showAlert()
        }

      }).catch(err =>{
        this.errors = err.response.data.errors
      })
      
    },
    formData(obj){
      var formData = new FormData();
      for (var key in obj) {
        formData.append(key, obj[key]);
      }
      return formData;
    },
    submitRegister() {
     this.$validator.validate().then(valid => {
      if (valid) {
        this.submit(this.register)
      }
    });
   },
   countDownChanged(dismissCountDown) {
    this.dismissCountDown = dismissCountDown
  },
  showAlert() {
    this.dismissCountDown = this.dismissSecs
  },

  setPlace(place) {
      this.currentPlace = place;
    },
    addMarker() {
      if (this.currentPlace) {
        const marker = {
          lat: this.currentPlace.geometry.location.lat(),
          lng: this.currentPlace.geometry.location.lng(),
        };
        this.markers.push({ position: marker });
        this.places.push(this.currentPlace);
        this.center = marker;
        this.currentPlace = null;
        this.register.map = JSON.stringify(marker);
      }
    },
    geolocate: function() {
      navigator.geolocation.getCurrentPosition(position => {
        this.center = {
          lat: position.coords.latitude,
          lng: position.coords.longitude,
        };
      });
    },
    updateCoordinates(location) {
            const marker = {
                lat: location.latLng.lat(),
                lng: location.latLng.lng(),
            };
            this.center = marker;
            this.currentPlace = null;
            this.register.map = JSON.stringify(marker);
        },

},
};
</script>
<style src='vue-multiselect/dist/vue-multiselect.min.css'></style>
<style>

.multiselect__input{
  width:0px!important;
}

.modal-header{
  display: none;
}

.modal-dialog {
    max-width: 250px;
    margin: 1.75rem auto;
}

.pac-target-input{
    width: 50%;
}

</style>